<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwCtrlUtils: CtrlJsonSerialize Programmer Manual</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwCtrlUtils
   &#160;<span id="projectnumber">8.5.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('CtrlJsonSerializeManual.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">CtrlJsonSerialize Programmer Manual </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>CtrlJsonSerialize can serialize and deserialize most of WinCC OA variable types inluding mappings, dyn_ arrays and vectors. In addition it works for user defined classes, structures and enumerated types. Nested objects are also supported.</p>
<p>An example string containing JSON formatted data is presented below: </p><div class="fragment"><div class="line">{</div>
<div class="line">  <span class="stringliteral">&quot;i&quot;</span>: 5,</div>
<div class="line">  <span class="stringliteral">&quot;s&quot;</span>: <span class="stringliteral">&quot;demo&quot;</span>,</div>
<div class="line">  <span class="stringliteral">&quot;b&quot;</span>: <span class="keyword">true</span>,</div>
<div class="line">  <span class="stringliteral">&quot;df&quot;</span>: [</div>
<div class="line">    3.91,</div>
<div class="line">    0,</div>
<div class="line">    0.5</div>
<div class="line">  ]</div>
<div class="line">}</div>
</div><!-- fragment --><p> That string can be a result of serialization of the object presented below: </p><div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">struct </span>Demo{</div>
<div class="line">  <span class="keywordtype">int</span> i;</div>
<div class="line">  <span class="keywordtype">string</span> s;</div>
<div class="line">  <span class="keywordtype">bool</span> b;</div>
<div class="line">  dyn_float df;</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  Demo d;</div>
<div class="line">  d.i = 5;</div>
<div class="line">  d.s = <span class="stringliteral">&quot;demo&quot;</span>;</div>
<div class="line">  d.b = <span class="keyword">true</span>;</div>
<div class="line">  d.df = makeDynFloat(3.91, 0, 0.5);</div>
<div class="line">  DebugTN(<a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>(d, <span class="keyword">false</span>));</div>
<div class="line">}</div>
<div class="ttc" id="agroup__CtrlJsonSerialize_html_ga008d751aa43d5039f0273f8ba410f670"><div class="ttname"><a href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a></div><div class="ttdeci">string fwJsonSerialize(const shared_ptr&lt; type &gt;|const type &amp;obj, [const mapping &amp;options=makeMapping(),] bool compact=true)</div><div class="ttdef"><b>Definition:</b> fwCtrlJsonSerialize-functions.dox:16</div></div>
</div><!-- fragment --><h1><a class="anchor" id="JsonFormat"></a>
JSON format and its limitations</h1>
<p>JSON format supports only limited number of data types. These are:</p><ul>
<li>Primitive (simple):<ul>
<li>Number (double precision floating point number)</li>
<li>String (double-qouted, with backslash escaping)</li>
<li>Boolean (either true or false)</li>
<li>Empty (null)</li>
</ul>
</li>
</ul>
<ul>
<li>Compound:<ul>
<li>Array (ordered sequence of values)</li>
<li>Object (collection of key - value pairs)</li>
</ul>
</li>
</ul>
<p>Please note, that when data is serialized to JSON, an information about its type is lost, if this type is not one of the simple types listed above.</p>
<p>If the data is serialized from, and later deserialized to an object, where all properties have known type, this peculiarity does not need to be considered. In such case, during deserialization, the variable type of particular object property is used to resolve the data type of JSON value encoding this property.</p>
<p>In the example from previous section, value of key "i" is deserialized to an integer value, even thogh in JSON it is treated as a double precision floating point number. This is because for object of type 'Demo', property 'i' is an integer.</p>
<p>An opposite situation occurs, when a mapping, where each key has a value of type 'int', is serialized. An attempt to deserialize it back to a mapping, results in a mapping containing same keys and values, but these values are of type 'float'.</p>
<div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  mapping m = makeMapping(<span class="stringliteral">&quot;a&quot;</span>, (<span class="keywordtype">int</span>)30);</div>
<div class="line">  <span class="keywordtype">string</span> json = <a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>(m);</div>
<div class="line">  mapping deserialized_m;</div>
<div class="line">  <a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>(json, deserialized_m);</div>
<div class="line">  DebugTN(getTypeName(m[<span class="stringliteral">&quot;a&quot;</span>])); <span class="comment">// prints: &quot;float&quot;</span></div>
<div class="line">}</div>
<div class="ttc" id="agroup__CtrlJsonSerialize_html_ga32bd1b5f5341e49bc7e6a3afb7771ce6"><div class="ttname"><a href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a></div><div class="ttdeci">int fwJsonDeserialize(const string &amp;json, shared_ptr&lt; type &gt;|type &amp;obj, const mapping &amp;options=makeMapping())</div><div class="ttdef"><b>Definition:</b> fwCtrlJsonSerialize-functions.dox:29</div></div>
</div><!-- fragment --><p>Below are listed example "weak" data types, for which original data type(s) may be lost pernamently after serialization (there is no possibility to resolve original type during deserialization):</p><ul>
<li>anytype, mixed (if initialized with value)</li>
<li>dyn_anytype, dyn_mixed initialized elements</li>
<li>values in mapping's key-value pairs</li>
<li>vector&lt;anytype&gt;, vector&lt;mixed&gt;, vector&lt;void&gt;</li>
<li>shared_ptr&lt;anytype&gt;, shared_ptr&lt;mixed&gt;, shared_ptr&lt;void&gt;</li>
<li>shared_ptr&lt;BaseClass&gt; when contains pointer to DerivedClass</li>
</ul>
<p>For struct and class objects, there is an option available to include type information in serialized JSON string. That enables the possibility of exact reconstruction of an object on deserialization to a "weak" type. For other variable types, however, there is no possibility to preserve type information after serializing to JSON.</p>
<h1><a class="anchor" id="ComparisonToWinccFunctions"></a>
CtrlJsonSerialize and WinCC OA JSON support</h1>
<p>WinCC OA already provides functions for data serialization and deserialization to/from JSON format. These two funtions are jsonEncode() and jsonDecode(). However they offer only basic, limited functionality. For example, jsonEncode() cannot handle serialization of nested ctrl++ objects and value returned by jsonDecode() has a type of JSON encoded data. For ctr++ objects this is a mapping, which forces class developer to write an additional code for providing effective deserialization of JSON string to object of the class. Such code needs to be maintained and kept up to date with modifications of class fields. In addition deserialization code needs to be provided for each class separately.</p>
<p>Given that, a decision was taken to implement functions offering JSON serialization and deserialization in scope of the JCOP framework. This allows to provide the same base functionality as WinCC OA functions do, overcome currently identified limitations and have possibility to extend it in the future according to the demands of the JCOP framework users community.</p>
<p>At the current stage, CtrlJsonSerialize functions are compatible with WinCC OA equivalents for most of the types. In addition <a class="el" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize()</a> allows for serialization of nested ctrl++ objects and <a class="el" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize()</a>, that returns deserialized value through an output argument, allows direct deserialization of JSON encoded value into the the desired type. An option has been introduced for class object to include their type information inside serialized JSON string and use that to reconstruct object on deserialization.</p>
<h1><a class="anchor" id="WinccTypesEncoding"></a>
WinCC OA types serialization</h1>
<p>Please find below a table presenting how different WinCC OA data types are encoded in JSON format by <a class="el" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize()</a> function.</p>
<table class="doxtable">
<tr>
<th>Ctrl data type</th><th>Value type in JSON</th><th>Encoding example</th><th>Remarks </th></tr>
<tr>
<td>anytype</td><td>Empty</td><td>[null]</td><td>Empty anytype (before first assignment), otherwise as for assigned type </td></tr>
<tr>
<td>mixed</td><td>Empty</td><td>[null]</td><td>Empty mixed (before first assignment), otherwise as for assigned type </td></tr>
<tr>
<td>bool</td><td>Boolean</td><td>[true]</td><td></td></tr>
<tr>
<td>int</td><td>Number</td><td>[-4562]</td><td></td></tr>
<tr>
<td>uint</td><td>Number</td><td>[924]</td><td></td></tr>
<tr>
<td>long</td><td>Number</td><td>[4873475273]</td><td>Loss of precision may happen - see below </td></tr>
<tr>
<td>ulong</td><td>Number</td><td>[224835936543]</td><td>Loss of precision may happen - see below </td></tr>
<tr>
<td>float/double</td><td>Number</td><td>[9375.378457]</td><td>NaN, +/-Inf not supported - serialized as Empty value </td></tr>
<tr>
<td>char</td><td>String</td><td>["66"]</td><td>ASCII character code in decimal form, example:"66" for 'B' </td></tr>
<tr>
<td>string</td><td>String</td><td>["example"]</td><td></td></tr>
<tr>
<td>time</td><td>String</td><td>["2020-03-17T09:08:03.707Z"]</td><td>UTC time in Extended Date/Time Format </td></tr>
<tr>
<td>bit32</td><td>String</td><td>["110(...)100"]</td><td>32-bit pattern value in binary form </td></tr>
<tr>
<td>bit64</td><td>String</td><td>["11010(...)10100"]</td><td>64-bit pattern value in binary form </td></tr>
<tr>
<td>blob</td><td>String</td><td>["FFAB003AFB"]</td><td>Each blob byte represented by 2 characters (representing hexadecimal number) </td></tr>
<tr>
<td>mapping</td><td>Object</td><td>{"a":5,"b":null}</td><td>Only mapping keys of type 'string' can be serialized, keys of any other type are discarded in serialized Object </td></tr>
<tr>
<td>dyn_ array</td><td>Array</td><td>["text", 30, bool]</td><td></td></tr>
<tr>
<td>dyn_dyn_ array</td><td>Array</td><td>[["a", "b"], []]</td><td></td></tr>
<tr>
<td>shared_ptr&lt;type&gt;</td><td>Empty</td><td>[null]</td><td>Uninitialized shared_ptr&lt;type&gt; (nullptr), otherwise as for type it points to </td></tr>
<tr>
<td>vector&lt;type&gt;</td><td>Array</td><td>[45, 0, 99]</td><td></td></tr>
<tr>
<td>ctrl++ enumerated type</td><td>Number</td><td>[5]</td><td>Number representing enum item </td></tr>
<tr>
<td>ctrl++ class/struct</td><td>Object</td><td>{"a":40,"b":true}</td><td>Collection of instance property name(string):value pairs </td></tr>
<tr>
<td>function_ptr</td><td>String</td><td>"MyClass::method"</td><td>Function name. For methods, a name is prepended by a scope name and delimited with '::'. nullptr is serialized to an empty string (note: jsonEncode() serializes it as "-null-"). Currently only serialization is supported </td></tr>
</table>
<p>In addition support for atime and errClass types is provided. As these types are rarely used, they are not included in this documentation. Serialization and deserialization is not provided for langString type.</p>
<dl class="section warning"><dt>Warning</dt><dd>64-bit integer values (long, ulong) may loose their precision after serialization to JSON. This is because they are encoded as double precision floating point number. The integer limits for this type is 2^53 (-9007199254740992 to +9007199254740992). Values outside of this range will be serialized with reduced precision.</dd></dl>
<h1><a class="anchor" id="DeserializationBehavior"></a>
Remarks on JSON deserialization</h1>
<p>Target object for deserialization is given as an output argument for <a class="el" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize()</a>. Data stored in JSON string is deserialized to the type of given target variable. If type of the JSON encoded data does not match to the type imposed by target variable, WRONG_JSON_VALUE_TYPE exception is raised and deserialization is aborted. However, there are variable types, that do not impose particular data type on the deserialized value. These are:</p><ul>
<li>anytype, mixed</li>
<li>elements of dyn_anytype, dyn_mixed</li>
<li>elements of vector&gt;anytype&lt;, vector&gt;mixed&lt;, vector&gt;void&lt;</li>
<li>shared_ptr&gt;anytype&lt;, shared_ptr&gt;mixed&lt;, shared_ptr&gt;void&lt;</li>
<li>mapping values</li>
</ul>
<p>When such variable is encountered by deserialization function, the value type, that is assigned to this variable, is resolved from JSON value type or optionally, for class/struct objects, from the inline type information if available. Table below presents mapping between JSON value types and WinCC OA data types to which given JSON value is assigned.</p>
<table class="doxtable">
<tr>
<th>Value type in JSON</th><th>Ctrl data type </th></tr>
<tr>
<td>Empty</td><td>anytype (unassigned) </td></tr>
<tr>
<td>Boolean</td><td>bool </td></tr>
<tr>
<td>Number</td><td>float </td></tr>
<tr>
<td>String</td><td>string </td></tr>
<tr>
<td>Array</td><td>dyn_anytype </td></tr>
<tr>
<td>Object</td><td>mapping </td></tr>
</table>
<p>Inline type information of class/struct object is stored as a value of "@class" key inside JSON object.</p>
<p>Please note, that JSON format requires to always enclose primitive (simple) values at JSON root level in square brackets. For example: '[5]' instead of only '5' - it is not a valid JSON. Therefore, when primitive value at JSON root level (such JSON contains effectively only this single value) is deserialized to variable of type anytype, this variable takes the new type: dyn_anytype. It is an expected behavior. It comes from the fact, that in such case it is not possible to determine, whether primitive value enclosed in square brackets should be treated as a primitive or as an array and by default a square brackets represents an array in JSON format.</p>
<div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  anytype a;</div>
<div class="line">  <a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>(<span class="stringliteral">&quot;[5]&quot;</span>, a);</div>
<div class="line">  DebugTN(getTypeName(a)); <span class="comment">// prints: &quot;dyn_anytype&quot;</span></div>
<div class="line">}</div>
</div><!-- fragment --><h1><a class="anchor" id="InlineTypeInfo"></a>
Optional inline type information</h1>
<p>Information about a type of a struct or class object can be included in serialized JSON by adding an option: "addObjectTypeProperty" with boolean value 'true' to the <a class="el" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize()</a> options map. </p><div class="fragment"><div class="line"><a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>([...], makeMapping(<span class="stringliteral">&quot;addObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
</div><!-- fragment --><p> JSON produced with that option contains an additional key-value pair "@class":"&lt;type_name&gt;" inline with key-value pairs representing object properties name and value.</p>
<p>Type information is used on deserialization only when an option "useObjectTypeProperty" with boolean value 'true' is included in <a class="el" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize()</a> options map. </p><div class="fragment"><div class="line"><a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>([...], makeMapping(<span class="stringliteral">&quot;useObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
</div><!-- fragment --><p> Type information is used when target variable is:</p><ul>
<li>anytype, mixed (or element of dyn_anytype, dyn_mixed array)</li>
<li>element of vector&lt;anytype&gt;, vector&lt;mixed&gt;, vector&lt;void&gt;</li>
<li>nullptr shared_ptr&lt;anytype&gt;, shared_ptr&lt;mixed&gt;, shared_ptr&lt;void&gt;</li>
<li>nullptr shared_ptr&lt;Class&gt;</li>
</ul>
<p>On deserialization to a shared_ptr&lt;Class&gt;, object type in JSON must be a derived type of a Class, otherwise a INCOMPATIBLE_INLINE_TYPE exception is raised.</p>
<p>When calling <a class="el" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize()</a> with "useObjectTypeProperty" option set and with target variable as listed above, type stored inline in JSON must be known for a script, from where deserialization function is called. If this is not the case a WRONG_INLINE_TYPE exception is raised.</p>
<p>If "useObjectTypeProperty" option is set, but an inline type information is not available, no exception is raised and deserialization works as if "useObjectTypeProperty" option is unset.</p>
<p>Note, that on deserialization to a class object or shared_ptr&lt;&gt; already initialized with an object of strong type, the inline type information is not used. In this case the type is imposed by the object.</p>
<p>Example serialization and deserialization of a struct object with type preservation: </p><div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">struct </span>Demo{</div>
<div class="line">  <span class="keywordtype">int</span> x;</div>
<div class="line">  <span class="keywordtype">int</span> y;</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  Demo d;</div>
<div class="line">  d.x = 4;</div>
<div class="line">  d.y = 1;</div>
<div class="line">  <span class="keywordtype">string</span> jsonWithTypeInfo = <a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>(d, makeMapping(<span class="stringliteral">&quot;addObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
<div class="line">  anytype a;</div>
<div class="line">  <a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>(jsonWithTypeInfo, a, makeMapping(<span class="stringliteral">&quot;useObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
<div class="line">  DebugTN(getTypeName(a)); <span class="comment">// prints: &quot;Demo&quot;</span></div>
<div class="line">}</div>
</div><!-- fragment --><p>Keeping exact object type is in particular useful when base class pointer stores a pointer to an object of derived class. Serialization and deserialization with type preservation allows to reconstruct correctly an object of derived class.</p>
<div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">class </span>Shape{</div>
<div class="line">  <span class="keywordtype">string</span> color;</div>
<div class="line"> </div>
<div class="line">  <span class="keyword">public</span> Shape(<span class="keywordtype">string</span> color){</div>
<div class="line">    this.color = color;</div>
<div class="line">  }</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><span class="keyword">class </span>Square : Shape{</div>
<div class="line">  <span class="keywordtype">int</span> sideLength;</div>
<div class="line"> </div>
<div class="line">  <span class="keyword">public</span> Square(<span class="keywordtype">int</span> sideLength, <span class="keywordtype">string</span> color) : Shape(color){</div>
<div class="line">    this.sideLength = sideLength;</div>
<div class="line">  }</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><span class="keyword">class </span>Other{</div>
<div class="line">  <span class="keywordtype">string</span> color;</div>
<div class="line">  <span class="keywordtype">int</span> sideLength;</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  shared_ptr&lt;Shape&gt; sq = <span class="keyword">new</span> Square(10, <span class="stringliteral">&quot;red&quot;</span>);</div>
<div class="line">  <span class="keywordtype">string</span> jsonWithTypeInfo = <a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>(sq, makeMapping(<span class="stringliteral">&quot;addObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
<div class="line">  shared_ptr&lt;Shape&gt; sh;</div>
<div class="line">  <a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>(jsonWithTypeInfo, sh, makeMapping(<span class="stringliteral">&quot;useObjectTypeProperty&quot;</span>, <span class="keyword">true</span>));</div>
<div class="line">  DebugTN(sh); <span class="comment">// prints: shared_ptr&lt;Shape&gt; -&gt; instance (...) of class Square (...)</span></div>
<div class="line">  shared_ptr&lt;Other&gt; o;</div>
<div class="line">  <span class="comment">//fwJsonDeserialize(jsonWithTypeInfo, o, makeMapping(&quot;useObjectTypeProperty&quot;, true)); // INCOMPATIBLE_INLINE_TYPE exception</span></div>
<div class="line">}</div>
</div><!-- fragment --><h1><a class="anchor" id="AcceptIncompleteObject"></a>
Deserialization if object properties are missing</h1>
<p>After new properties are added to a class, objects of that class serialized before, cannot be deserialized anymore. This is because they contain incomplete information about an object of upgraded class. Deserialization attempt causes a MISSING_OBJ_PROPERTY exception to be raised.</p>
<p>To allow reconstruction of the objects serialized before, "acceptIncompleteJson" option with boolean value 'true' should be added to <a class="el" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize()</a> options map.</p>
<p>This option is recommended to use, if necessary, in an upgrade scripts.</p>
<div class="fragment"><div class="line"><span class="preprocessor">#uses &quot;CtrlJsonSerialization&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">struct </span>Coord{</div>
<div class="line">  <span class="keywordtype">int</span> x;</div>
<div class="line">  <span class="keywordtype">int</span> y;</div>
<div class="line">  <span class="keywordtype">int</span> z; <span class="comment">// newly added property</span></div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line">main(){</div>
<div class="line">  <span class="keywordtype">string</span> coordSerialized = <span class="stringliteral">&quot;{\&quot;x\&quot;:20,\&quot;y\&quot;:30}&quot;</span>; <span class="comment">// serialized object of old Coord struct</span></div>
<div class="line">  Coord c;</div>
<div class="line">  <span class="comment">//fwJsonDeserialize(coordSerialized, c); // MISSING_OBJ_PROPERTY exception</span></div>
<div class="line">  <a class="code" href="group__CtrlJsonSerialize.html#ga32bd1b5f5341e49bc7e6a3afb7771ce6">fwJsonDeserialize</a>(coordSerialized, c, makeMapping(<span class="stringliteral">&quot;acceptIncompleteJson&quot;</span>, <span class="keyword">true</span>));</div>
<div class="line">  c.z = 10;</div>
<div class="line">  coordSerialized = <a class="code" href="group__CtrlJsonSerialize.html#ga008d751aa43d5039f0273f8ba410f670">fwJsonSerialize</a>(c, <span class="keyword">false</span>);</div>
<div class="line">  DebugTN(coordSerialized);</div>
<div class="line">}</div>
</div><!-- fragment --> </div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
